import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

class zmazectl extends Panel {
   Checkbox hexagonalRoomsCheckbox;
   zmaze3d zmaze3d;
   Checkbox squareRoomsCheckbox;

   public zmazectl(zmaze3d var1) {
      this.zmaze3d = var1;
      ((Container)this).add(new Button("Neues Spiel"));
      ((Container)this).add(new Button("Spiel loesen"));
      ((Container)this).add(new Button("Spiel loeschen"));
      this.hexagonalRoomsCheckbox = new Checkbox("Hexagonales Labyrinth");
      this.hexagonalRoomsCheckbox.setState(var1.hexagonalRooms);
      ((Container)this).add("South", this.hexagonalRoomsCheckbox);
      this.squareRoomsCheckbox = new Checkbox("Quadratisches Labyrinth");
      this.squareRoomsCheckbox.setState(!var1.hexagonalRooms);
      ((Container)this).add("South", this.squareRoomsCheckbox);
      ((Container)this).add(new Button("Info"));
   }

   public boolean keyDown(Event var1, int var2) {
      boolean var3;
      if (this.zmaze3d.zmazecan.p.alreadyPainting) {
         var3 = false;
      } else if (!this.zmaze3d.solutionDisplayed && !this.zmaze3d.zmazecan.p.userHasSolved) {
         if (this.zmaze3d.hexagonalRooms) {
            this.zmaze3d.message.setText("Verwenden Sie Home, Up, PgUp, Ende, Dn Pfeil, oder PgDn zum Spielen.");
         } else {
            this.zmaze3d.message.setText("Verwenden Sie die Pfeiltasten zum Spielen.");
         }

         if (this.zmaze3d.hexagonalRooms) {
            switch (var2) {
               case 49:
                  this.zmaze3d.zmazecan.p.hexKey(1);
                  var3 = true;
                  break;
               case 50:
                  this.zmaze3d.zmazecan.p.hexKey(3);
                  var3 = true;
                  break;
               case 51:
                  this.zmaze3d.zmazecan.p.hexKey(5);
                  var3 = true;
                  break;
               case 52:
                  var3 = true;
                  break;
               case 54:
                  var3 = true;
                  break;
               case 55:
                  this.zmaze3d.zmazecan.p.hexKey(0);
                  var3 = true;
                  break;
               case 56:
                  this.zmaze3d.zmazecan.p.hexKey(2);
                  var3 = true;
                  break;
               case 57:
                  this.zmaze3d.zmazecan.p.hexKey(4);
                  var3 = true;
                  break;
               case 1000:
                  this.zmaze3d.zmazecan.p.hexKey(0);
                  var3 = true;
                  break;
               case 1001:
                  this.zmaze3d.zmazecan.p.hexKey(1);
                  var3 = true;
                  break;
               case 1002:
                  this.zmaze3d.zmazecan.p.hexKey(4);
                  var3 = true;
                  break;
               case 1003:
                  this.zmaze3d.zmazecan.p.hexKey(5);
                  var3 = true;
                  break;
               case 1004:
                  this.zmaze3d.zmazecan.p.hexKey(2);
                  var3 = true;
                  break;
               case 1005:
                  this.zmaze3d.zmazecan.p.hexKey(3);
                  var3 = true;
                  break;
               case 1006:
                  var3 = true;
                  break;
               case 1007:
                  var3 = true;
                  break;
               default:
                  var3 = false;
            }
         } else {
            switch (var2) {
               case 49:
                  var3 = true;
                  break;
               case 50:
                  this.zmaze3d.zmazecan.p.sqrKey(1);
                  var3 = true;
                  break;
               case 51:
                  var3 = true;
                  break;
               case 52:
                  this.zmaze3d.zmazecan.p.sqrKey(0);
                  var3 = true;
                  break;
               case 54:
                  this.zmaze3d.zmazecan.p.sqrKey(2);
                  var3 = true;
                  break;
               case 55:
                  var3 = true;
                  break;
               case 56:
                  this.zmaze3d.zmazecan.p.sqrKey(3);
                  var3 = true;
                  break;
               case 57:
                  var3 = true;
                  break;
               case 1000:
                  var3 = true;
                  break;
               case 1001:
                  var3 = true;
                  break;
               case 1002:
                  var3 = true;
                  break;
               case 1003:
                  var3 = true;
                  break;
               case 1004:
                  this.zmaze3d.zmazecan.p.sqrKey(3);
                  var3 = true;
                  break;
               case 1005:
                  this.zmaze3d.zmazecan.p.sqrKey(1);
                  var3 = true;
                  break;
               case 1006:
                  this.zmaze3d.zmazecan.p.sqrKey(0);
                  var3 = true;
                  break;
               case 1007:
                  this.zmaze3d.zmazecan.p.sqrKey(2);
                  var3 = true;
                  break;
               default:
                  var3 = false;
            }
         }

         if (this.zmaze3d.zmazecan.p.userHasSolved) {
            this.zmaze3d.message.setText("Geschafft - Herzlichen Glueckwunsch!");
         }
      } else {
         this.zmaze3d.message.setText("");
         var3 = false;
      }

      return var3;
   }

   public boolean action(Event var1, Object var2) {
      boolean var3;
      if (var1.target instanceof Button) {
         String var4 = (String)var2;
         if (var4.equals("Neues Spiel")) {
            this.zmaze3d.solutionDisplayed = false;
            this.zmaze3d.zmazecan.previousHeight = 0;
            this.zmaze3d.zmazecan.previousWidth = 0;
            this.zmaze3d.zmazecan.paint(this.zmaze3d.zmazecan.getGraphics());
         } else if (var4.equals("Spiel loesen")) {
            this.zmaze3d.message.setText("");
            this.zmaze3d.solutionDisplayed = true;
            if (this.zmaze3d.zmazecan.p.alreadyPainting) {
               this.zmaze3d.zmazecan.paint(this.zmaze3d.zmazecan.getGraphics());
            } else if (this.zmaze3d.hexagonalRooms) {
               this.zmaze3d.zmazecan.p.hexDisplaySolution();
            } else {
               this.zmaze3d.zmazecan.p.sqrDisplaySolution();
            }
         } else if (var4.equals("Spiel loeschen")) {
            if (this.zmaze3d.hexagonalRooms) {
               this.zmaze3d.message.setText("Verwenden Sie Home, Up, PgUp, Ende, Dn Pfeil, oder PgDn zum Spielen.");
            } else {
               this.zmaze3d.message.setText("Verwenden Sie die Pfeiltasten zum Spielen.");
            }

            this.zmaze3d.solutionDisplayed = false;
            this.zmaze3d.clearUserAttempts = true;
            this.zmaze3d.zmazecan.paint(this.zmaze3d.zmazecan.getGraphics());
         } else if (var4.equals("Info")) {
            this.zmaze3d.message.setText("Copyright (c) 1996 James L. Dean.  Dieses Programm darf frei benutzt und weitergegeben werden.");
         }

         var3 = true;
      } else if (var1.target == this.hexagonalRoomsCheckbox) {
         this.squareRoomsCheckbox.setState(false);
         this.hexagonalRoomsCheckbox.setState(true);
         if (!this.zmaze3d.hexagonalRooms) {
            this.zmaze3d.hexagonalRooms = true;
            this.zmaze3d.solutionDisplayed = false;
            this.zmaze3d.zmazecan.previousHeight = 0;
            this.zmaze3d.zmazecan.previousWidth = 0;
            this.zmaze3d.zmazecan.paint(this.zmaze3d.zmazecan.getGraphics());
         }

         var3 = true;
      } else if (var1.target == this.squareRoomsCheckbox) {
         this.squareRoomsCheckbox.setState(true);
         this.hexagonalRoomsCheckbox.setState(false);
         if (this.zmaze3d.hexagonalRooms) {
            this.zmaze3d.hexagonalRooms = false;
            this.zmaze3d.solutionDisplayed = false;
            this.zmaze3d.zmazecan.previousHeight = 0;
            this.zmaze3d.zmazecan.previousWidth = 0;
            this.zmaze3d.zmazecan.paint(this.zmaze3d.zmazecan.getGraphics());
         }

         var3 = true;
      } else {
         var3 = false;
      }

      return var3;
   }
}
